package com.example.nfc_example1;

import java.io.IOException;
import java.io.UnsupportedEncodingException;

import android.net.Uri;
import android.nfc.FormatException;
import android.nfc.NdefMessage;
import android.nfc.NdefRecord;
import android.nfc.NfcAdapter;
import android.nfc.Tag;
import android.nfc.tech.Ndef;
import android.os.Bundle;
import android.os.Parcelable;
import android.app.Activity;
import android.content.Intent;
import android.util.Log;
import android.view.Menu;
import android.widget.TextView;
import android.widget.Toast;

public class NFC extends Activity {
//	TextView NfcMessage = (TextView)findViewById(R.id.textViewNfcMessage);
	
	@Override
	protected void onCreate(Bundle savedInstanceState) {
		super.onCreate(savedInstanceState);
		setContentView(R.layout.activity_nfc);
		
//1.Look for adapter		
		NfcAdapter NexusNfcAdapter = NfcAdapter.getDefaultAdapter(this);
		if(NexusNfcAdapter == null) {
			Toast.makeText(getApplicationContext(), "NFC is not supported" , Toast.LENGTH_LONG).show();
			finish();
			return;
		}
/*2.Check if adapter is enabled
		if(!NexusNfcAdapter.isEnabled()) {
			NfcMessage.setText("NFC is disabled");
		} else {
			NfcMessage.setText("NFC is enabled");	
		} 			
*/	}	

		@Override
	public void onResume() {
			super.onResume();
		if(NfcAdapter.ACTION_NDEF_DISCOVERED.equals(getIntent().getAction()))
	    {
	        Tag tag=getIntent().getParcelableExtra(NfcAdapter.EXTRA_TAG);
	        byte[] tagUid = tag.getId();
	        Toast.makeText(this,"NDEF UID: "+tagUid.toString() ,Toast.LENGTH_LONG).show();
/*	    
	        Parcelable[] rawNdefMessages=getIntent().getParcelableArrayExtra(NfcAdapter.EXTRA_NDEF_MESSAGES);
			if(rawNdefMessages!=null) {
	            NdefMessage[] ndefMessages = new NdefMessage[rawNdefMessages.length];
	            for(int i=0;i<rawNdefMessages.length;i++) {
	                ndefMessages[i]=(NdefMessage)rawNdefMessages[i];
	            }
	        }
*/
	        NdefRecord appRecord = NdefRecord.createApplicationRecord("com.example.przelaczniki");
	        NdefMessage message = new NdefMessage(appRecord);
	        Ndef ndef = Ndef.get(tag);
            try {
				ndef.connect();
				ndef.writeNdefMessage(message);
		        ndef.close();
			} catch (IOException e) {
				// TODO Auto-generated catch block
				e.printStackTrace();
			} catch (FormatException e) {
				// TODO Auto-generated catch block
				e.printStackTrace();
			}	        
	        
	        
	    }  else if(NfcAdapter.ACTION_TECH_DISCOVERED.equals(getIntent().getAction())) {
	        Tag tag=getIntent().getParcelableExtra(NfcAdapter.EXTRA_TAG);
	        byte[] tagUid=tag.getId();
	        Toast.makeText(this,"TECH UID: "+tagUid.toString(),Toast.LENGTH_LONG).show();

//	        NdefRecord rtdUriRecord = NdefRecord.createUri("http://www.wsg.byd.pl");
//	        NdefMessage message = new NdefMessage(rtdUriRecord);

//	        NdefRecord appRecord = NdefRecord.createApplicationRecord("com.android.chrome");
	        NdefRecord appRecord = NdefRecord.createApplicationRecord("com.example.przelaczniki");
	        NdefMessage message = new NdefMessage(appRecord);
	        Ndef ndef = Ndef.get(tag);
            try {
				ndef.connect();
				ndef.writeNdefMessage(message);
		        ndef.close();
			} catch (IOException e) {
				// TODO Auto-generated catch block
				e.printStackTrace();
			} catch (FormatException e) {
				// TODO Auto-generated catch block
				e.printStackTrace();
			}
           
            
/*	        try {
				write("Tag testowy",tag);
			} catch (IOException e) {
				// TODO Auto-generated catch block
				e.printStackTrace();
			} catch (FormatException e) {
				// TODO Auto-generated catch block
				e.printStackTrace();
			}
*/	        
	        
	    }  else if(NfcAdapter.ACTION_TAG_DISCOVERED.equals(getIntent().getAction())) {
	        Tag tag=getIntent().getParcelableExtra(NfcAdapter.EXTRA_TAG);
	        byte[] tagUid = tag.getId();
	        Toast.makeText(this,"TAG UID: "+tagUid.toString(),Toast.LENGTH_LONG).show();
	        
	       
	    }
	    else
	    {
	        Toast.makeText(this,"Enclose your tag to read it",Toast.LENGTH_LONG).show();
	    }
	}

		private NdefRecord createRecord(String text) throws UnsupportedEncodingException {

            String lang = "en";
            byte[] textBytes = text.getBytes();
            byte[] langBytes = lang.getBytes("US-ASCII");
            int langLength = langBytes.length;
            int textLength = textBytes.length;

            byte[] payload = new byte[1 + langLength + textLength];
            payload[0] = (byte) langLength;

            System.arraycopy(langBytes, 0, payload, 1, langLength);
            System.arraycopy(textBytes, 0, payload, 1 + langLength, textLength);

            NdefRecord recordNFC = new NdefRecord(NdefRecord.TNF_WELL_KNOWN, NdefRecord.RTD_TEXT, new byte[0], payload);
            return recordNFC;
        }		
		
        private void write(String text, Tag tag) throws IOException, FormatException {

            NdefRecord[] records = { createRecord(text) };
            NdefMessage message = new NdefMessage(records);
            Ndef ndef = Ndef.get(tag);
            ndef.connect();
            ndef.writeNdefMessage(message);
            ndef.close();
        }
		

	@Override
	public boolean onCreateOptionsMenu(Menu menu) {
		// Inflate the menu; this adds items to the action bar if it is present.
		getMenuInflater().inflate(R.menu.nfc, menu);
		return true;
	}

}
